# the follwing scripts can be found here:

check_column_names_res1d.ipnyb:
- quick code to access res1d files to see what names the result files for specific reach or node names have

param_spec_unit_factor.ipynb:
- short script to access the unit factors used in the model to use in the parameter_config.xlsx

optimization_prep:
- contains the optimization preparation to create the 
- uses a gaussian filter to smooth the data and cross correlation to consider errors in the hydrological model

water-quality-optimization:
- input is amodel file, the results files and the excel files defined below
- script that contains the automatic optimization of the MIKE+ model



# The following excel files need to be saved in the folder where the .sqlite file is saved:

calibration_event_times.xlsx
- gives the preperation script input on which times are used
- The excel file contains sensor in the first header line, the kind of column in the second header line and the event as the first column. Rows without values in times are ignored
- all event rows should contain the timeframes for the comparison in the calibration

sensor_positions.xlsx:
- This table defines for each concentration sensor where it is positioned whithin the model
- It also contains a the position and name of a discharge sensor, which is used to adjust the time shift later
- Note that chainages are only approximate. You should use a chainage that is available in the result files. Check the hd results files wit hthe given script beforehand

event_dict.xlsx:
- this excel file contains information if multiple events are simulated together
- if you are doing this: Simplay write under event the single events and under result file the result file name in which the event is included

parameter config.xlsx:
- this table contains the parameters that should be calibrated and also the min and amx values for the calibration
- as there might be some unit difference between the python input and that in MIKE+ itself, unitfactors are given for the parameters, which were investigated here. All further parametern need to be looked up. A script to help is "param_spec_unit_factor.ipynb"
- to use it directly just fill out columns D, J and K
- the second sheet "sqlite_table_names" contains all names to look for the the MUID to access the parameters

optim_parts.xlsx:
- contains information regarding what timeframe of the model and sensor data should be compared. The follwing information has to be inserted:
- label: name of label in reference.csv data
- event: event name
- sensor: sensorname, also in label
- EventWeight: Can be used to givve events a higher weight than other. Default=1
- Start: Start time of event or the start time of the part of the event that should be calibrated
- End: End time of event or the end time of the part of the event that should be calibrated
- Timestep: Of model and measuring data that should be compared
- Simulation name: Name of simulation if not event name, defined in event:dict.xlsx
- ResultFile: Link to model result file, relative to folder where the .sqlite of the model is saved
- ResultReach / REsultNode: Define where the measurement is compared to the model data
- Result_Column: Name of the Column in which the necessary data is saved on the res1d files. This needs to be changed if a AD or ST model is used.
- StartOriginal/EndOriginal: If due to cross-correlation other times were used, the original times can be found here

reference.csv:
- created by the optimization_prepr.ipnyb to get the sensor data for comparison
- if the prep is not wanted you can also create this fiel directly



